Package org.eclipse.m2m.atl.engine.vm

# Class ASMEmitter

java.lang.Object
org.eclipse.m2m.atl.engine.vm.nativelib.ASMNativeObject
org.eclipse.m2m.atl.engine.vm.nativelib.ASMOclAny
org.eclipse.m2m.atl.engine.vm.ASMEmitter

public class ASMEmitter extends ASMOclAny
This class is used by ATL compiler to create an ASM file.

## Field Summary

Fields
Modifier and Type
Field
Description
`static ASMOclType`
`myType`

### Fields inherited from class org.eclipse.m2m.atl.engine.vm.nativelib.ASMNativeObject

`nativeImpl`

## Constructor Summary

Constructors
Constructor
Description
`ASMEmitter()`

## Method Summary

Modifier and Type
Method
Description
`void`
`addField(String name, String type)`
`void`
`addLineNumberEntry(String id, int begin, int end)`
`void`
`addLocalVariableEntry(int slot, String name, int begin, int end)`
`void`
`addOperation(String name)`
`void`
`addOperationWithoutLVE(String name)`
`void`
`addParameter(String name, String type)`
`void`
`addParameterWithoutLVE(String name, String type)`
`void`
`beginLineNumberEntry(String id)`
`void`
`beginLocalVariableEntry(String id, String name)`
`void`
`dumpASM(String fileName)`
`void`
`emit(String mnemonic, String param)`
`void`
`emitSimple(String mnemonic)`
`void`
`emitWithoutLabel(String mnemonic, String param)`
`void`
`endLineNumberEntry(String id)`
`void`
`endLocalVariableEntry(String id)`
`void`
`finishOperation()`
`ASM`
`getASM()`
`String`
`getVersion()`
`void`
`newASM(String name)`
`void`
`newUnnamedASM()`
`void`
`setContext(String type)`
`void`
`setName(String name)`
`void`
`setVersion(String version)`

### Methods inherited from class org.eclipse.m2m.atl.engine.vm.nativelib.ASMOclAny

`asBag, asSequence, asSet, check, debug, findOperation, findOperation, get, getHelper, getNamedTargetFromSource, getOclAnyType, getType, invoke, invoke, invokeSuper, isHelper, oclIsKindOf, oclIsTypeOf, oclIsUndefined, oclType, operatorEQ, operatorNE, output, refGetValue, refImmediateComposite, refImmediateComposite, refInvokeOperation, refSetValue, refUnsetValue, set, setType, toString, unset`

### Methods inherited from class org.eclipse.m2m.atl.engine.vm.nativelib.ASMNativeObject

`getNativeImpl`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### myType

public static ASMOclType myType

## Constructor Details

### ASMEmitter

public ASMEmitter()

## Method Details

### newASM

public void newASM(String name)

### newUnnamedASM

public void newUnnamedASM()

### setName

public void setName(String name)

### addField

public void addField(String name, String type)

### finishOperation

public void finishOperation()

### addOperation

public void addOperation(String name)

### addOperationWithoutLVE

public void addOperationWithoutLVE(String name)

### setContext

public void setContext(String type)

### addParameter

public void addParameter(String name, String type)

### addParameterWithoutLVE

public void addParameterWithoutLVE(String name, String type)

### beginLineNumberEntry

public void beginLineNumberEntry(String id)

### endLineNumberEntry

public void endLineNumberEntry(String id)

### addLineNumberEntry

public void addLineNumberEntry(String id, int begin, int end)

### beginLocalVariableEntry

public void beginLocalVariableEntry(String id, String name)

### endLocalVariableEntry

public void endLocalVariableEntry(String id)

### addLocalVariableEntry

public void addLocalVariableEntry(int slot, String name, int begin, int end)

### emitSimple

public void emitSimple(String mnemonic)

### emit

public void emit(String mnemonic, String param)

### emitWithoutLabel

public void emitWithoutLabel(String mnemonic, String param)

### getASM

public ASM getASM()

### dumpASM

public void dumpASM(String fileName)

### getVersion

public String getVersion()

### setVersion

public void setVersion(String version)